;  PROG9 - Conditinal Branching
;
;  This Program Uses the Simulator to Demonstrate how Conditional
;   Branching Can be Accomplished in the 8051.
;
;  This program will run in the UMPS simulator for a DS80C320.
;
;  Myke Predko
;  98.02.09
;
;  Hardware Notes:
;   This program is only meant to run on the Simulator

;  Variable Declarations
;  R0 in Bank 0 is used as an Index Register

Temp EQU 020h                   ;  Temporary Variable (In Bit Memory)

;  Mainline
 org 0                          ;  Execution Starts Here

  mov    Temp,#084h             ;  Initialize the Variable for Checking Later

  clr    A                      ;  Do a Jnz if "A" is Not Zero

  jnz    NZLabel                ;  If A != 0 goto Label

  nop                           ;  End up here if "A" == 0

NZLabel:

  mov    R0,#Temp               ;  Have R0 Point to Temp

  cjne   @R0,#0,CNZLabel        ;  Jump to Label, if @R0 != 0

  nop                           ;  Execute This NOP if @R0 == 0

CNZLabel:

  cjne   A,#0,CNELabel          ;  Jump if "A" does not equal Zero

  nop                           ;  Execute this if "A" does equal Zero

CNELabel:

Loop:                           ;  Loop Here Forever when Finished
  ajmp   Loop
